type
    ExpansionRom_t = struct {
	ushort er_Type;
	ushort er_Product;
	ushort er_Flags;
	ushort er_Reserved03;
	uint er_Manufacturer;
	ulong er_SerialNumber;
	uint er_InitDiagVec;
	ushort er_Reserved0c, er_Reserved0d, er_Reserved0e, er_Reserved0f;
    },

    ExpansionControl_t = struct {
	ushort ec_Interrupt;
	ushort ec_Reserved11;
	ushort ec_BaseAddress;
	ushort ec_ShutUp;
	ushort ec_Reserved14, ec_Reserved15, ec_Reserved16, ec_Reserved17,
	       ec_Reserved18, ec_Reserved19, ec_Reserved1a, ec_Reserved1b,
	       ec_Reserved1c, ec_Reserved1d, ec_Reserved1e, ec_Reserved1f;
    };

ulong
    E_SLOTSIZE		= 0x10000,
    E_SLOTMASK		= 0xffff,
    E_SLOTSHIFT 	= 16,

    E_EXPANSIONBASE	= 0xe80000,
    E_EXPANSIONSIZE	= 0x080000,
    E_EXPANSIONSLOTS	= 8,

    E_MEMORYBASE	= 0x200000,
    E_MEMORYSIZE	= 0x800000,
    E_MEMORYSLOTS	= 128;

ushort
    ERT_TYPEMASK	= 0xc0,
    ERT_TYPEBIT 	= 6,
    ERT_TYPESIZE	= 2,
    ERT_NEWBOARD	= 0xc0,

    ERT_MEMMASK 	= 0x07,
    ERT_MEMBIT		= 0,
    ERT_MEMSIZE 	= 3,

    ERTB_CHAINEDCONFIG	= 3,
    ERTB_DIAGVALID	= 4,
    ERTB_MEMLIST	= 5,

    ERTF_CHAINEDCONFIG	= 1 << ERTB_CHAINEDCONFIG,
    ERTF_DIAGVALID	= 1 << ERTB_DIAGVALID,
    ERTF_MEMLIST	= 1 << ERTB_MEMLIST,

    ERFB_MEMSPACE	= 7,
    ERFB_NOSHUTUP	= 6,

    ERFF_MEMSPACE	= 1 << ERFB_MEMSPACE,
    ERFF_NOSHUTUP	= 1 << ERFB_NOSHUTUP,

    ECIB_INTENA 	= 1,
    ECIB_RESET		= 3,
    ECIB_INT2PEND	= 4,
    ECIB_INT6PEND	= 5,
    ECIB_INT7PEND	= 6,
    ECIB_INTERRUPTING	= 7,

    ECIF_INTENA 	= 1 << ECIB_INTENA,
    ECIF_RESET		= 1 << ECIB_RESET,
    ECIF_INT2PEND	= 1 << ECIB_INT2PEND,
    ECIF_INT6PEND	= 1 << ECIB_INT6PEND,
    ECIF_INT7PEND	= 1 << ECIB_INT7PEND,
    ECIF_INTERRUPTING	= 1 << ECIB_INTERRUPTING;

type
    DiagArea_t = struct {
	ushort da_Config;
	ushort da_Flags;
	uint da_Size;
	uint da_DiagPoint;
	uint da_BootPoint;
	uint da_Name;
	uint da_Reserved01, da_Reserved02;
    };

ushort
    DAC_BUSWIDTH	= 0xC0,
    DAC_NIBBLEWIDE	= 0x00,
    DAC_BYTEWIDE	= 0x40,
    DAC_WORDWIDE	= 0x80,

    DAC_BOOTTIME	= 0x30,
    DAC_NEVER		= 0x00,
    DAC_CONFIGTIME	= 0x10,
    DAC_BINDTIME	= 0x20;

extern
    EC_MEMADDR(ushort slot)ulong,
    ERT_MEMNEEDED(ushort t)ulong,
    ERT_SLOTSNEEDED(ushort t)ushort;
