type
    Task_t = unknown 92,
    MsgPort_t = unknown 34,
    Message_t = unknown 20,
    Library_t = unknown 34,
    BPTR = unknown 4,
    Handle_t = unknown 4,
    Lock_t = unknown 4,
    Segment_t = unknown 4,

    BSTR = ulong,

    Process_t = struct {
	Task_t pr_Task;
	MsgPort_t pr_MsgPort;
	uint pr_Pad;
	Segment_t pr_SegList;
	ulong pr_StackSize;
	*byte pr_GlobVec;
	ulong pr_TaskNum;
	BPTR pr_StackBase;
	ulong pr_Result2;
	Lock_t pr_CurrentDir;
	Handle_t pr_CIS;
	Handle_t pr_COS;
	*Process_t pr_ConsoleTask;
	*Process_t pr_FileSystemTask;
	Segment_t pr_CLI;
	*byte pr_ReturnAddr;
	*byte pr_PktWait;
	*Window_t pr_WindowPtr;
    },

    FileHandle_t = struct {
	*Message_t fh_Link;
	*MsgPort_t fh_Port;
	*MsgPort_t fh_Type;
	BPTR fh_Buf;
	ulong fh_Pos;
	ulong fh_End;
	ulong fh_Func1, fh_Func2, fh_Func3;
	ulong fh_Arg1, fh_Arg2;
    },

    DosPacket_t = struct {
	*Message_t dp_Link;
	*MsgPort_t dp_Port;
	ulong dp_Type;
	ulong dp_Res1, dp_Res2;
	ulong dp_Arg1, dp_Arg2, dp_Arg3, dp_Arg4, dp_Arg5, dp_Arg6, dp_Arg7;
    },

    StandardPacket_t = struct {
	Message_t sp_Msg;
	DosPacket_t sp_Pkt;
    };

ulong
    ACTION_NIL			= 0,
    ACTION_GET_BLOCK		= 2,
    ACTION_SET_MAP		= 4,
    ACTION_DIE			= 5,
    ACTION_EVENT		= 6,
    ACTION_CURRENT_VOLUME	= 7,
    ACTION_LOCATE_OBJECT	= 8,
    ACTION_RENAME_DISK		= 9,
    ACTION_WRITE		= 'W' - '\e',
    ACTION_READ 		= 'R' - '\e',
    ACTION_FREE_LOCK		= 15,
    ACTION_DELETE_OBJECT	= 16,
    ACTION_RENAME_OBJECT	= 17,

    ACTION_COPY_DIR		= 19,
    ACTION_WAIT_CHAR		= 20,
    ACTION_SET_PROTECT		= 21,
    ACTION_CREATE_DIR		= 22,
    ACTION_EXAMINE_OBJECT	= 23,
    ACTION_EXAMINE_NEXT 	= 24,
    ACTION_DISK_INFO		= 25,
    ACTION_INFO 		= 26,

    ACTION_SET_COMMENT		= 28,
    ACTION_PARENT		= 29,
    ACTION_TIMER		= 30,
    ACTION_INHIBIT		= 31,
    ACTION_DISK_TYPE		= 32,
    ACTION_DISK_CHANGE		= 33;

type
    DosLibrary_t = struct {
	Library_t dl_lib;
	*RootNode_t dl_Root;
	*byte dl_GV;
	ulong dl_A2, dl_A5, dl_A6;
    },

    RootNode_t = struct {
	BPTR rn_TaskArray;
	Segment_t rn_ConsoleSegment;
	DateStamp_t rn_Time;
	Segment_t rn_RestartSeg;
	BPTR rn_Info;
	Segment_t rn_FileHandlerSegment;
    },

    DosInfo_t = struct {
	BPTR di_McName;
	BPTR di_DevInfo;
	BPTR di_Devices;
	BPTR di_Handlers;
	*Process_t di_NetHand;
    },

    CommandLineInterface_t = struct {
	ulong cli_Result2;
	BSTR cli_SetName;
	Lock_t cli_CommandDir;
	ulong cli_ReturnCode;
	BSTR cli_CommandName;
	ulong cli_FailLevel;
	BSTR cli_Prompt;
	Handle_t cli_StandardInput;
	Handle_t cli_CurrentInput;
	BSTR cli_CommandFile;
	ulong cli_Interactive;
	ulong cli_Background;
	Handle_t cli_CurrentOutput;
	ulong cli_DefaultStack;
	Handle_t cli_StandardOutput;
	Segment_t cli_Module;
    },

    DeviceList_t = struct {
	BPTR dl_Next;
	ulong dl_Type;
	*MsgPort_t dl_Task;
	Lock_t dl_Lock;
	DateStamp_t dl_VolumeDate;
	BPTR dl_LockList;
	ulong dl_DiskType;
	ulong dl_unused;
	BSTR dl_Name;
    };

ulong
    DLT_DEVICE		= 0,
    DLT_DIRECTORY	= 1,
    DLT_VOLUME		= 2;

type
    FileLock_t = struct {
	BPTR fl_Link;
	ulong fl_Key;
	long fl_Access;
	*MsgPort_t fl_Task;
	BPTR fl_Volume;
    };
